=== debian/changelog ===
pylucene (3.5.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Compile Java with backwards compatible bytecode. (Closes: #678131)

 -- Niels Thykier <niels@thykier.net>  Fri, 21 Jun 2013 16:21:25 +0200

pylucene (3.5.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/unique_classes.patch:
    - Cherry-pick patch from upstream branch_3x SVN (r1240640) to rename
      classes whose python name would not be unique (Closes: #679368).

 -- Luca Falavigna <dktrkranz@debian.org>  Mon, 06 Aug 2012 11:43:34 +0200

pylucene (3.5.0-1) unstable; urgency=low

  * New maintainer (closes: 670179)
  * New upstream release
  * Switch to dpkg-source 3.0 (quilt) format
  * Switch to machine-readable debian/copyright
  * Bump debian/compat to 8, drop debian/pycompat
  * Switch from cdbs to dh
  * Add watch file
  * Build for all supported versions of python2 (closes: 581198, 632240)
  * Rename binary package to python-lucene (closes: 581197)
  * Add -dbg package

 -- Dmitry Nezhevenko <dion@dion.org.ua>  Mon, 23 Apr 2012 16:43:55 +0300

pylucene (2.3.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Adding python-all-dev and python-all to B-D (closes: 496332)
  * Add a dependency on python 2.5 (closes: 497479)

 -- Rene Mayorga <rmayorga@debian.org.sv>  Sat, 30 Aug 2008 19:55:25 -0600

pylucene (2.3.1-1) unstable; urgency=low

  * Initial release (closes: 490254)

 -- Jeff Breidenbach <jab@debian.org>  Wed, 16 Apr 2008 10:39:49 -0700
