=== debian/control ===
Source: pylucene
Section: python
Priority: optional
Maintainer: Dmitry Nezhevenko <dion@dion.org.ua>
Build-Depends: debhelper (>= 8), jcc, default-jdk, ant, python-setuptools (>= 0.6b3), python-all-dev (>= 2.6.6-3)
Standards-Version: 3.9.3
X-Python-Version: >= 2.6
Homepage: http://lucene.apache.org/pylucene/

Package: python-lucene
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, default-jre-headless
Replaces: pylucene (<< 2.3.1-1.1+b1)
Breaks: pylucene (<< 2.3.1-1.1+b1)
Description: Python extension for accessing Java Lucene
 PyLucene is a Python extension for accessing Java Lucene. Its goal
 is to allow you to use Lucene's text indexing and searching
 capabilities from Python.

Package: python-lucene-dbg
Section: debug
Architecture: any
Priority: extra
Depends: python-lucene (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for python-lucene
 PyLucene is a Python extension for accessing Java Lucene. Its goal
 is to allow you to use Lucene's text indexing and searching
 capabilities from Python.
 .
 This package contains the debugging symbols for python-lucene.

Package: pylucene
Section: oldlibs
Architecture: any
Depends: python-lucene, ${misc:Depends}
Description: Python extension for accessing Java Lucene (transitional dummy package)
 This is a transitional dummy package. It can safely be removed.
