=== debian/rules ===
#!/usr/bin/make -f

export ANT := ant -propertyfile $(CURDIR)/debian/ant.properties
export JAVA_HOME := /usr/lib/jvm/default-java

# number of cpp files to generate from jar. JCC will split
# generated code to specified number of files and then compile
# all of them
export NUM_FILES := 16

PYTHON_VERSION=$(shell pyversions -s)

%:
	dh $@ --with python2

override_dh_auto_clean:
	rm -rf dist lucene.egg-info
	for inter in $(PYTHON_VERSION); do \
		PYTHON=$$inter JCC="$$inter -m jcc" make clean || exit $$? ; \
		rm -rf build-$$inter; \
	done

# temporary no tests
override_dh_auto_test:

override_dh_auto_build:
	ls -la /usr/lib/jvm/
	for inter in $(PYTHON_VERSION); do \
		PYTHON=$$inter JCC="$$inter -m jcc.__main__" \
			JCCFLAGS="--output build-$$inter" make || exit $$?; \
	done

override_dh_auto_install:
	for inter in ${PYTHON_VERSION}; do \
		PYTHON=$$inter JCC="$$inter -m jcc.__main__" \
			JCCFLAGS="--use-distutils --output build-$$inter --install-dir debian/python-lucene/usr/lib/$$inter/dist-packages" \
			make install || exit $$?; \
	done

override_dh_strip:
	dh_strip --dbg-package=python-lucene-dbg

#override_dh_installchangelogs:
#	dh_installchangelogs CHANGES
