=== debian/watch ===
version=3
http://www.apache.org/dist/lucene/pylucene/ pylucene-([0-9\.]+).*\.tar\.gz
