=== debian/changelog ===
pylucene (4.10.1+dfsg-2) unstable; urgency=medium

  * Add wrapper around jcc to avoid build failure on armel, armhf, mips,
    mipsel (Closes: #845083, #845084)
  * Change Build-Depends to libasm-java (Closes: #839722)
  * Update debian/watch

 -- Dmitry Nezhevenko <dion@dion.org.ua>  Fri, 03 Feb 2017 15:10:46 +0200

pylucene (4.10.1+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #740992) 
  * Repack upstream tarball to get rid of embedded copy of liblucene4.10-java.
    and JCC compiler
  * Bump debian/compat to 9, no changes required
  * Bump Standards-Version to 3.9.8, no changes required
  * Remove old pylucene transition package
  * Drop obsolete X-Python-Version 
  * Drop embedded copy of lucene-java-4.10 in binary package (add Depends: 
    liblucene4.10-java)
  * Add Build-Depends: antlr3, libasm4-java (new upstream depencencies,
    embedded copies were included by upstream) 
  * Drop unique_classes.patch patch (not needed anymore)
  * Enable tests
  * Apply security hardening in build flags (Closes: #740994)
  * Switch to -dbgsym package for debug symbols
  * Configure 'uscan(1)' to verify upstream signature on source releases
    (thanks to Ben Finney) (Closes: #741062, #741063)

 -- Dmitry Nezhevenko <dion@dion.org.ua>  Fri, 22 Jul 2016 10:54:06 +0300
