=== debian/rules ===
#!/usr/bin/make -f

export ANT := ant -propertyfile $(CURDIR)/debian/ant.properties
export JAVA_HOME := /usr/lib/jvm/default-java

# Hardening
export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
export JCC_CFLAGS:=$(CFLAGS)

# number of cpp files to generate from jar. JCC will split
# generated code to specified number of files and then compile
# all of them
export NUM_FILES := 16

PYTHON_VERSION=$(shell pyversions -s)

%:
	dh $@ --with python2

override_dh_auto_clean:
	rm -rf dist lucene.egg-info
	find test -name "*.pyc" -delete
	for inter in $(PYTHON_VERSION); do \
		PYTHON=$$inter JCC="debian/jcc_wrapper $$inter -m jcc" make clean || exit $$? ; \
		rm -rf build-$$inter; \
	done

override_dh_auto_test:
	for inter in $(PYTHON_VERSION); do \
		PYTHON=$$inter JCC="debian/jcc_wrapper $$inter -m jcc.__main__" \
			JCCFLAGS="--output build-$$inter" make test || exit $$?; \
	done

override_dh_auto_build:
	ls -la /usr/lib/jvm/
	for inter in $(PYTHON_VERSION); do \
		PYTHON=$$inter JCC="debian/jcc_wrapper $$inter -m jcc.__main__" \
			JCCFLAGS="--output build-$$inter --debug" make compile || exit $$?; \
	done

# JCC is not happy about symlinks in destination dir. So we should rm -rf dst dir before
#
# Here we will also replace .jar files in /usr/lib/pythonX.X/dist-packages with
# symlink to system java package. Or move it to /usr/share/python-lucene
# if it's custom file
override_dh_auto_install:
	set -e; \
	for inter in ${PYTHON_VERSION}; do \
		DST_DIR=debian/python-lucene/usr/lib/$$inter/dist-packages; \
		SHARED_DIR=debian/python-lucene/usr/share/python-lucene; \
		SHARED_DIR_REL=../../../../share/python-lucene; \
		rm -rf $$DST_DIR; \
		PYTHON=$$inter JCC="debian/jcc_wrapper $$inter -m jcc.__main__" \
			JCCFLAGS="--use-distutils --output build-$$inter --install-dir $$DST_DIR" \
			make install || exit $$?; \
			for JAR in $$(find $$DST_DIR -type f -name '*.jar'); do \
				FN=$$(basename $$JAR) ;\
				DST=$$(find lucene-java-4.10.x -type l -name $$FN); \
				if [ -n "$$DST" ]; then \
					rm $$JAR; \
					cp -P $$DST $$JAR; \
				else \
					mkdir -p $$SHARED_DIR; \
					mv $$JAR $$SHARED_DIR; \
					ln -s $$SHARED_DIR_REL/$$FN $$JAR; \
				fi; \
				echo $$FN - $$DST; \
			done \
	done

override_dh_strip:
	dh_strip --ddeb-migration='python-lucene-dbg (<< 4.10.1~)'

#override_dh_installchangelogs:
#	dh_installchangelogs CHANGES
