=== debian/watch ===
# debian/watch
# Debian uscan file for ‘pylucene’ package.
# Manpage: ‘uscan(1)’

# Compulsory line, this is a version 3 file.
version=4

# Current version from Apache Software Foundation.
# The source tarball filename includes a suffix (commonly “-1-src”) that is
# not part of the version number.
opts="dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg,pgpsigurlmangle=s/$/.asc/" \
     http://www.apache.org/dist/lucene/pylucene/ \
     pylucene-([0-9\.]+)(?:-[0-9]+)?-src\.tar\.gz
